﻿Public Class Form1

    ' 受信情報.
    Dim Cls_Client As NSDSocket.NSDReceive = Nothing

    ' ログイン用イベントの有無.
    Dim Bln_AddHandler_ServerLogin As Boolean = False
    ' 切断用イベントの有無.
    Dim Bln_AddHandler_ServerDisconnected As Boolean = False

    ' ソケットファイル用クラス.
    Dim Cls_SFile As NSDSocket.NSDSocket_File = Nothing

    Dim BlnCls_FileUpDownload As Boolean = False    ' ファイルのアップ、ダウンロード状態.
    Dim StrCls_UploadFile As String = Nothing       ' アップロードするファイル名.
    Dim StrCls_DownLoadFolder As String = Nothing   ' ダウンロードするフォルダー名.

    #Region ""
        ' ボタンなどのコントロールEnabled処理.
        Delegate Sub Button_Enabled_Invoke()
        Delegate Sub PB_Set_Invoke(ByVal Size As UInt64)

        Delegate Sub End_Upload_Delegate( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
        ' ファイル情報の終了処理.
        Delegate Sub End_GetFInfo_Delegate( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileFolderListEventArgs)
        ' カレントフォルダーの表示処理.
        Delegate Sub End_GetCurrentFolder_Delegate( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketCurrentFolderEventArgs)
        ' ログイン時の処理.
        Delegate Sub Enabled_Login_Delegate()
    #End Region

    #Region "Form."
        #Region "Sub Form1_Load : Loadイベント."
            Private Sub Form1_Load( sender As System.Object,  e As System.EventArgs) Handles MyBase.Load
                Try
                    ' 初期化.
                        Me.Lbl_FilePercent.Text = Nothing
                        Me.Lbl_FSize.Text = Nothing

                    If (Cls_SFile Is Nothing) Then
                        Cls_SFile = New NSDSocket.NSDSocket_File
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Form1_FormClosing : FormClosingイベント."
            Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
                Try
                    Dim Bln_Cancel As Boolean = False
                    If Not (Cls_SFile Is Nothing) Then
                        If Cls_SFile.IsRun(Cls_Client) Then
                            ' 処理中.
                            Bln_Cancel = True
                        End If
                    End If
                    ' キャンセル有無をセットします.
                    e.Cancel = Bln_Cancel

                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Form1_FormClosed : FormClosedイベント."
            Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
                Try
                    If Not (Cls_SFile Is Nothing) Then
                        Cls_SFile.Dispose()
                        Cls_SFile = Nothing
                    End If

                    ' NSDClientを解放します.
                    MyClass.NSDClientDispose()
                Catch ex As Exception

                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub NSDClientDispose : NSDClientを解放します."
        Private Sub NSDClientDispose()
            Try
                If Not (Cls_Client Is Nothing) Then
                    Cls_Client.Dispose()
                    Cls_Client = Nothing
                End If
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Btn_Login_Click : サーバーにログインします."
        Private Sub Btn_Btn_Login_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Login.Click
            Try
                ' サーバー名.
                Dim Str_ServerName As String = Me.Txt_Server.Text.Trim
                ' ポート№.
                Dim Int_PortNo As Integer = Me.NUD_PortNo.Value
                ' ログイン名.
                Dim Str_LoginName As String = Me.Txt_LoginName.Text.Trim
                ' パスワード.
                Dim Str_Password As String = Me.Txt_Password.Text.Trim

                If (Cls_Client Is Nothing) Then
                    Cls_Client = New NSDSocket.NSDReceive()
                End If

                If [String].IsNullOrEmpty(Str_ServerName) Then
                    Str_ServerName = My.Computer.Name
                End If

                ' サーバーログイン用イベントの設定.
                AddHandler Cls_Client.ServerLogin, AddressOf MyClass.ServerLogin
                Bln_AddHandler_ServerLogin = True
                ' サーバー切断用イベントの設定.
                AddHandler Cls_Client.Disconnected, AddressOf MyClass.ServerDisconnected
                Bln_AddHandler_ServerDisconnected = True
                ' サーバーに接続.
                If Not Cls_Client.Connect(Str_ServerName, Int_PortNo, Str_LoginName, Str_Password) Then
                    MsgBox("サーバーに接続できません。")
                    MyClass.ServerDisconnectSub()
                End If

            Catch ex As Exception

            End Try
        End Sub

        #Region "Sub ServerLogin : サーバーにログイン."
            Private Sub ServerLogin( ByVal sender As System.Object,  ByVal e As System.EventArgs)
                Try
                    MyClass.ServerLogin_Sub()
                Catch ex As Exception

                End Try
            End Sub

            #Region "Sub ServerLogin_Sub : ログイン時の表示処理."
                Private Sub ServerLogin_Sub()
                    Try
                        If Me.InvokeRequired() Then
                            Dim ELD As New Enabled_Login_Delegate(AddressOf ServerLogin_Sub)
                            Me.Invoke(ELD)
                        Else
                            Me.Btn_Login.Enabled = False
                            Me.P_Connect.Enabled = False
                            Me.Btn_Logoff.Enabled = True
                            Me.GB_FF.Enabled = True
                            With Me.LV_FInfo
                                .Items.Clear()
                            End With

                            MsgBox("サーバーにログインしました。")
                        End If

                    Catch ex As Exception

                    End Try
                End Sub
            #End Region
        #End Region
    #End Region

    #Region "Sub Btn_Logoff_Click : サーバーからログオフ."
        Private Sub Btn_Logoff_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Logoff.Click
            Try
                MyClass.ServerDisconnectSub()
            Catch ex As Exception
            End Try
        End Sub

        #Region "サーバーとの接続解除."
            Private Sub ServerDisconnected( ByVal sender As System.Object,  ByVal e As System.EventArgs)
                Try
                    MyClass.ServerDisconnectSub()
                Catch ex As Exception
                End Try
            End Sub

            #Region "Sub ServerDisconnectSub : 接続解除時の表示処理. "
                Public Sub ServerDisconnectSub()
                    Try
                        If Bln_AddHandler_ServerLogin Then
                            ' サーバーログイン用イベントの解除.
                            RemoveHandler Cls_Client.ServerLogin, AddressOf ServerLogin
                            Bln_AddHandler_ServerLogin = false
                        End If
                        If Bln_AddHandler_ServerDisconnected Then
                            ' サーバー切断用イベントの解除.
                            RemoveHandler Cls_Client.Disconnected, AddressOf ServerDisconnected
                            Bln_AddHandler_ServerDisconnected = False
                        End If

                        If Me.InvokeRequired Then
                            Me.Invoke(New Button_Enabled_Invoke(AddressOf Button_Enabled))
                        Else
                            Me.Button_Enabled()
                        End If

                    Catch ex As Exception

                    End Try
                End Sub

                #Region "Sub Button_Enabled : ボタンなどのコントロールEnabled処理."
                    Private Sub Button_Enabled()
                        Try
                            ' NSDClientを解放します.
                            MyClass.NSDClientDispose()

                            Me.Btn_Login.Enabled = True
                            Me.P_Connect.Enabled = True
                            Me.Btn_Logoff.Enabled = False
                            Me.GB_FF.Enabled = False
                        Catch ex As Exception
                        End Try
                    End Sub
                #End Region
            #End Region
        #End Region
    #End Region

    #Region "ファイル情報の取得."
        Private Sub Btn_FileInfo_Click( sender As System.Object,  e As System.EventArgs) Handles Btn_FileInfo.Click
            Try
                MyClass.GetFInfo(Me.Txt_Folder.Text, False)
            Catch ex As Exception
            End Try
        End Sub

        #Region "Sub GetFInfo : ファイル情報の取得."
            Private Sub GetFInfo(ByVal StrVal_Folder As String, ByVal BlnVal_SetCurrentFolder As Boolean)
                Try
                    ' サーバーのカレントフォルダーを取得.
                    Dim Str_Folder As String = Nothing
                    If BlnVal_SetCurrentFolder Then
                        If Cls_SFile.GetServerCurrentFolder(Cls_Client, Str_Folder) Then
                            If Not [String].IsNullOrEmpty(Str_Folder) AndAlso _
                               Not [String].IsNullOrEmpty(StrVal_Folder) Then
                                If StrVal_Folder.StartsWith(System.IO.Path.DirectorySeparatorChar) AndAlso _
                                   Str_Folder.EndsWith(System.IO.Path.DirectorySeparatorChar) Then
                                    StrVal_Folder = StrVal_Folder.Substring(1)
                                ElseIf Not StrVal_Folder.StartsWith(System.IO.Path.DirectorySeparatorChar) AndAlso _
                                       Not Str_Folder.EndsWith(System.IO.Path.DirectorySeparatorChar) Then
                                    StrVal_Folder = System.IO.Path.DirectorySeparatorChar & StrVal_Folder
                                End If
                            End If
                            Str_Folder &= StrVal_Folder
                        End If
                    End If
                    ' ファイル情報を取得します.
                    If Cls_SFile.GetServerFileInfo(Cls_Client, Str_Folder, AddressOf MyClass.End_GetFInfo) Then
                        ’カレントフォルダーを取得します.
                        MyClass.Set_End_GetCurrentFolder(Me, New NSDSocket.NSDSocket_File.NSDSocketCurrentFolderEventArgs(0, Str_Folder))
                    End If

                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub End_GetFInfo : ファイル情報の終了処理."
            Private Sub End_GetFInfo( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileFolderListEventArgs)
                Try
                    MyClass.Set_End_GetFInfo(sender, e)
                Catch ex As Exception
                End Try
            End Sub

            #Region "Sub Set_End_GetFInfo : ファイル情報の終了処理(表示用)."
                Private Sub Set_End_GetFInfo( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileFolderListEventArgs)
                    Try
                        If Me.InvokeRequired() Then
                            Dim EGF As New End_GetFInfo_Delegate(AddressOf Set_End_GetFInfo)
                            Me.Invoke(EGF, New Object(){sender, e})
                        Else
                            Me.Lbl_FCount.Text = "件数："
                            With Me.LV_FInfo
                                .Items.Clear()
                                Me.RB_Download.Enabled = False
                                Me.Btn_FileDelete.Enabled = False

                                ' フォルダーのセット.
                                If Not (e.FolderList Is Nothing) Then
                                    For Int_Loop As Integer = 0 To e.FolderList.Count - 1
                                        Dim OneFInfo As NSDSocket.NSDSocket_File.NSDSocketFileInfo = e.FolderList(Int_Loop)
                                        ' 名前.
                                        Dim OneLvItem As ListViewItem = .Items.Add(OneFInfo.Name)
                                        ' 属性.
                                        OneLvItem.SubItems.Add("フォルダー")
                                        OneLvItem.Tag = OneFInfo
                                    Next
                                End If

                                ' ファイルのセット.
                                If Not (e.FileList Is Nothing) Then
                                    For Int_Loop As Integer = 0 To e.FileList.Count - 1
                                        Dim OneFInfo As NSDSocket.NSDSocket_File.NSDSocketFileInfo = e.FileList(Int_Loop)
                                        ' 名前.
                                        Dim OneLvItem As ListViewItem = .Items.Add(OneFInfo.Name)
                                        ' 属性.
                                        OneLvItem.SubItems.Add(OneFInfo.Attributes)
                                        ' サイズ.
                                        OneLvItem.SubItems.Add(OneFInfo.Length.ToString("#,0"))
                                        ' 作成日.
                                        OneLvItem.SubItems.Add(OneFInfo.CreationTime)
                                        ' 最終更新日.
                                        OneLvItem.SubItems.Add(OneFInfo.LastWriteTime)
                                        OneLvItem.Tag = OneFInfo
                                    Next
                                End If

                                Me.Lbl_FCount.Text = "件数：" & .Items.Count.ToString()
                            End With
                        End If
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region
        #End Region
    #End Region

    #Region "カレントフォルダーの取得."
        #Region "Sub Btn_CurrentFolder_Click : カレントフォルダーを取得します."
            Private Sub Btn_CurrentFolder_Click( sender As System.Object,  e As System.EventArgs) Handles Btn_CurrentFolder.Click
                Try
                    Cls_SFile.GetServerCurrentFolder(Cls_Client, AddressOf MyClass.End_GetCurrentFolder)
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub End_GetCurrentFolder : カレントフォルダーの取得終了処理."
            Private Sub End_GetCurrentFolder( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketCurrentFolderEventArgs)
                Try
                    MyClass.Set_End_GetCurrentFolder(sender, e)
                Catch ex As Exception
                End Try
            End Sub

            #Region "Sub Set_End_GetCurrentFolder : カレントフォルダーの表示."
                Private Sub Set_End_GetCurrentFolder( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketCurrentFolderEventArgs)
                    Try
                        If Me.InvokeRequired() Then
                            Dim EGF As New End_GetCurrentFolder_Delegate(AddressOf Set_End_GetCurrentFolder)
                            Me.Invoke(EGF, New Object(){sender, e})
                        Else
                            Me.Txt_Folder.Text = e.CurrentFolder
                        End If
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region
        #End Region
    #End Region

    #Region "Sub Btn_FileDelete_Click : ファイルの削除."
        Private Sub Btn_FileDelete_Click( sender As System.Object,  e As System.EventArgs) Handles Btn_FileDelete.Click
            Try
                Do
                    Dim Str_DeleteFile As String = Nothing
                    With Me.LV_FInfo
                        If (.SelectedItems Is Nothing) OrElse _
                            (.SelectedItems.Count = 0) Then
                            MsgBox("削除するファイルが選択されていません。")
                            Exit Do
                        Else
                            Str_DeleteFile = .SelectedItems(0).SubItems(0).Text
                        End If

                        Dim Str_Msg As String = "「" & Str_DeleteFile & "」を削除します。" & ControlChars.CrLf & "よろしいですか？"
                        If MsgBox(Str_Msg,MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                            ' ファイルを削除します.
                            If Cls_SFile.DeleteFile(Cls_Client, Str_DeleteFile) Then
                                Str_Msg = "ファイルを削除しました。" & ControlChars.CrLf & ControlChars.CrLf & "ファイル情報を取得します。" & ControlChars.CrLf & "よろしいですか？"
                                If MsgBox(Str_Msg, MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                                    Me.Btn_FileInfo.PerformClick()
                                End If
                            Else
                                MsgBox(Cls_SFile.GetEndMsg(Cls_SFile.ErrNo))
                            End If
                        End If

                    End With
                Loop While (False)
            Catch ex As Exception
            End Try
        End Sub
    #End Region

    #Region "ファイルのアップロードまたはダウンロード."
        Private Sub Btn_File_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_File.Click
            Try
                If Not BlnCls_FileUpDownload Then
                    Dim Bln_Err As Boolean = True
                    Do
                        BlnCls_FileUpDownload = True
                        Me.Btn_File.Text = "中止"

                        Select Case Me.RB_Upload.Checked
                            Case True
                            ' アップロード.
                                ' ファイルを選択します.
                                Dim Str_Filter As String = "すべてのファイル (*.*)|*.*"
                                Using Ofd As New System.Windows.Forms.OpenFileDialog
                                    With Ofd
                                        .Multiselect = False
                                        .ReadOnlyChecked = False
                                        .Filter = Str_Filter
                                        .Title = "アップロードするファイルを選択してください。"
                                        .FileName = StrCls_UploadFile
                                        If .ShowDialog() = Windows.Forms.DialogResult.OK Then
                                            ' アップロードファイルを選択しました.
                                            StrCls_UploadFile = .FileName
                                        Else
                                            Exit Do
                                        End If
                                    End With
                                End Using

                                ' プログレスバーをセット.
                                Dim Fi As New IO.FileInfo(StrCls_UploadFile)
                                With Me.PB_File
                                    .Minimum = 0
                                    .Value = 0
                                    If Fi.Length <> 0 Then
                                        .Maximum = Fi.Length
                                    Else
                                        .Maximum = 1
                                    End If
                                End With
                                Me.Lbl_FilePercent.Text = Nothing
                                Me.Lbl_FSize.Text = "(0/" & Me.PB_File.Maximum.ToString() & ")"

                                ' ファイルをアップロードします.
                                Bln_Err = Not Cls_SFile.UploadFile(Cls_Client, StrCls_UploadFile, AddressOf End_Upload, AddressOf Run_Upload)

                            Case False
                            ' ダウンロード.
                                Dim Str_DownloadFile As String = Nothing
                                With Me.LV_FInfo
                                    If (.SelectedItems Is Nothing) OrElse _
                                       (.SelectedItems.Count = 0) Then
                                        MsgBox("ダウンロードするファイルが選択されていません。")
                                        Exit Do
                                    Else
                                        Str_DownloadFile = .SelectedItems(0).SubItems(0).Text
                                    End If
                                End With

                                ' ダウンロードするフォルダーを指定します.
                                Using FolderDialog As New FolderBrowserDialog
                                    With FolderDialog
                                        .Description = "ダウンロードファイルを保存するフォルダーを選択してください。"
                                        .SelectedPath = StrCls_DownLoadFolder
                                        .ShowNewFolderButton = True
                                        If .ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
                                            ' ダウンロード先をセットします.
                                            StrCls_DownLoadFolder = .SelectedPath
                                        Else
                                            Exit Do
                                        End If
                                    End With
                                End Using

                                ' ファイルをダウンロードします.
                                Bln_Err = Not Cls_SFile.DownloadFile(Cls_Client, Str_DownloadFile, StrCls_DownLoadFolder, AddressOf MyClass.Start_Download, AddressOf MyClass.End_Download, AddressOf MyClass.Run_Download)
                        End Select
                    Loop While (False)
                    If Bln_Err Then
                        BlnCls_FileUpDownload = False
                        Me.Btn_File.Text = "実行"
                    End If

                Else
                    ' 中止します.
                    BlnCls_FileUpDownload = False
                    Me.Btn_File.Text = "実行"

                    Select Case Me.RB_Upload.Checked
                        Case True
                        ' アップロード.
                            Cls_SFile.StopUploadFile()
                        Case False
                        ' ダウンロード.
                            Cls_SFile.StopDownloadFile()
                    End Select
                End If

            Catch ex As Exception

            End Try
        End Sub

        #Region "ファイルアップロード用."
            #Region "ファイルアップロード終了のイベント."
                Private Sub End_Upload( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
                    Try
                        BlnCls_FileUpDownload = False
                        MyClass.Set_End_Upload(sender, e)

                    Catch ex As Exception

                    End Try
                End Sub

                #Region "Sub Set_End_Upload : 終了処理の画面表示."
                    Private Sub Set_End_Upload( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
                        Try
                            If Me.InvokeRequired() Then
                                Dim EUD As New End_Upload_Delegate(AddressOf Set_End_Upload)
                                Me.Invoke(EUD, New Object(){sender, e})
                            Else
                                MsgBox(Cls_SFile.GetEndMsg(e.ErrNo))
                                Me.Btn_File.Text = "実行"
                                ' プログレスバーをセット.
                                With Me.PB_File
                                    .Value = .Minimum
                                End With
                                Me.Lbl_FilePercent.Text = Nothing
                                Me.Lbl_FSize.Text = Nothing
                            End If
                        Catch ex As Exception

                        End Try
                    End Sub
                #End Region
            #End Region

            #Region "ファイルアップロード中のイベント."
                Private Sub Run_Upload(ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
                    Try
                        If Me.InvokeRequired Then
                            Me.Invoke(New PB_Set_Invoke(AddressOf PB_Set_Upload), New Object() {e.FileSize} )
                        Else
                            Me.PB_Set_Upload(e.FileSize)
                        End If
                    Catch ex As Exception
                    End Try
                End Sub

                #Region "Sub PB_Set_Upload : アップロード中の画面表示."
                    Private Sub PB_Set_Upload(ByVal IntVal_FileSize As UInt64)
                        Try

                            With Me.PB_File
                                .Value = IntVal_FileSize
                            End With
                            Me.Lbl_FilePercent.Text = Fix((IntVal_FileSize / Me.PB_File.Maximum) * 100).ToString() & "%"
                            Me.Lbl_FSize.Text = "(" & IntVal_FileSize.ToString() & "/" & Me.PB_File.Maximum.ToString() & ")"

                        Catch ex As Exception

                        End Try
                    End Sub
                #End Region
            #End Region
        #End Region

        #Region "ファイルダウンロード用."
            #Region "ファイルダウンロード開始のイベント."
                Private Sub Start_Download(ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
                    Try
                        If Me.InvokeRequired Then
                            Me.Invoke(New PB_Set_Invoke(AddressOf PB_Set_StartDownload), New Object() {e.SourceFileSize} )
                        Else
                            Me.PB_Set_StartDownload(e.SourceFileSize)
                        End If
                    Catch ex As Exception
                    End Try
                End Sub

                #Region "Sub PB_Set_StartDownload : ダウンロード開始の画面表示."
                    Private Sub PB_Set_StartDownload(ByVal IntVal_FileSize As UInt64)
                        Try
                            With Me.PB_File
                                .Maximum = IntVal_FileSize
                                .Value = 0
                            End With
                            Me.Lbl_FilePercent.Text = "0%"
                            Me.Lbl_FSize.Text = "(0/" & IntVal_FileSize.ToString() & ")"

                        Catch ex As Exception

                        End Try
                    End Sub
                #End Region
            #End Region

            #Region "ファイルダウンロード終了のイベント."
                Private Sub End_Download( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
                    Try
                        BlnCls_FileUpDownload = False
                        MyClass.Set_End_Download(sender, e)

                    Catch ex As Exception

                    End Try
                End Sub

                #Region "Sub Set_End_Downlload : 終了処理の画面表示."
                    Private Sub Set_End_Download( ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
                        Try
                            If Me.InvokeRequired() Then
                                Dim EUD As New End_Upload_Delegate(AddressOf Set_End_Download)
                                Me.Invoke(EUD, New Object(){sender, e})
                            Else
                                MsgBox(Cls_SFile.GetEndMsg(e.ErrNo))
                                Me.Btn_File.Text = "実行"
                                ' プログレスバーをセット.
                                With Me.PB_File
                                    .Value = .Minimum
                                End With
                                Me.Lbl_FilePercent.Text = Nothing
                                Me.Lbl_FSize.Text = Nothing
                            End If
                        Catch ex As Exception

                        End Try
                    End Sub
                #End Region
            #End Region

            #Region "ファイルダウンロード中のイベント."
                Private Sub Run_Download(ByVal sender As System.Object, ByVal e As NSDSocket.NSDSocket_File.NSDSocketFileEventArgs)
                    Try
                        If Me.InvokeRequired Then
                            Me.Invoke(New PB_Set_Invoke(AddressOf PB_Set_Download), New Object() {e.FileSize} )
                        Else
                            Me.PB_Set_Download(e.FileSize)
                        End If
                    Catch ex As Exception
                    End Try
                End Sub

                #Region "Sub PB_Set_Download : ダウンロード中の画面表示."
                    Private Sub PB_Set_Download(ByVal IntVal_FileSize As UInt64)
                        Try

                            With Me.PB_File
                                .Value = IntVal_FileSize
                            End With
                            Me.Lbl_FilePercent.Text = Fix((IntVal_FileSize / Me.PB_File.Maximum) * 100).ToString() & "%"
                            Me.Lbl_FSize.Text = "(" & IntVal_FileSize.ToString() & "/" & Me.PB_File.Maximum.ToString() & ")"

                        Catch ex As Exception

                        End Try
                    End Sub
                #End Region
            #End Region
        #End Region
    #End Region

    #Region "LV_FInfo : リストビュー."
        #Region "Sub LV_FInfo_MouseDoubleClick : MouseDoubleClick."
            Private Sub LV_FInfo_MouseDoubleClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles LV_FInfo.MouseDoubleClick
                Try
                    Do
                        With Me.LV_FInfo
                            If (.SelectedItems Is Nothing) OrElse _
                               (.SelectedItems.Count = 0) Then
                                ' ファイル、フォルダーが選択されていません.
                                Exit Do
                            End If

                            Dim OneFInfo As NSDSocket.NSDSocket_File.NSDSocketFileInfo = CType(.SelectedItems.Item(0).Tag, NSDSocket.NSDSocket_File.NSDSocketFileInfo)
                            If (OneFInfo.Attributes And FileAttribute.Directory) Then
                                ' ディレクトリを確認.

                                ' ファイル情報の取得.
                                MyClass.GetFInfo(.SelectedItems.Item(0).Text, True)
                            End If
                        End With
                    Loop While (False)
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub LV_FInfo_SelectedIndexChanged : 項目の選択."
            Private Sub LV_FInfo_SelectedIndexChanged( sender As System.Object,  e As System.EventArgs) Handles LV_FInfo.SelectedIndexChanged
                Try
                    Do
                        With Me.LV_FInfo
                            If (.SelectedItems Is Nothing) OrElse _
                               (.SelectedItems.Count = 0) Then
                                ' ファイル、フォルダーが選択されていません.
                                Me.GB_UDFile.Enabled = False
                                Me.RB_Download.Enabled = False
                                Me.Btn_FileDelete.Enabled = False
                                Exit Do
                            Else
                                Me.GB_UDFile.Enabled = True
                            End If

                            Dim OneFInfo As NSDSocket.NSDSocket_File.NSDSocketFileInfo = CType(.SelectedItems.Item(0).Tag, NSDSocket.NSDSocket_File.NSDSocketFileInfo)
                            Dim Bln_Enabled As Boolean = Not ((OneFInfo.Attributes And FileAttribute.Directory) = FileAttribute.Directory)
                            Me.RB_Download.Enabled = Bln_Enabled
                            Me.Btn_FileDelete.Enabled = Bln_Enabled
                        End With
                    Loop While (False)
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region
End Class
