﻿Public Class Frm_Server
    Dim StrCls_StdFolder As String = Application.StartupPath & "\SampleDataFolder"

    #Region "Delegate."
        ’ListView用.
        Delegate Sub Set_LV_Info_Delegate(ByVal StrVal_LoginName As String, ByVal StrVal_UserName As String, ByVal DateVal_ConnectTime As DateTime, ByVal ClsVal_Receive As NSDSocket.NSDReceive)
        Delegate Sub Delete_LV_Info_Delegate(ByVal e As NSDSocket.NSDServerEventArgs)

        ' アップロード用.
        Delegate Sub Set_LV_UploadInfo_Delegate(ByVal e As NSDSocket.NSDReceiveWriteDataEventArgs)
        ' ダウンロード用.
        Delegate Sub Set_LV_DownloadInfo_Delegate(ByVal e As NSDSocket.NSDSendDataEventArgs)
    #End Region

    #Region "Sub Frm_Server_Load : Loadイベント."
        Private Sub Frm_Server_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Try
                Me.LV_Info.GetType().InvokeMember( _
                    "DoubleBuffered", _
                    System.Reflection.BindingFlags.NonPublic Or System.Reflection.BindingFlags.Instance Or System.Reflection.BindingFlags.SetProperty, _
                    Nothing, _
                    Me.LV_Info, _
                    New Object() {True})

                ' コンピュータ名の設定.
                Me.Lbl_Name_Value.Text = My.Computer.Name

                Dim Bln_FileWrite As Boolean = False    ' ファイル書き込みフラグ.
                ' ユーザーリストを読み込みます.
                Dim Str_FileName As String = StrCls_StdFolder & "\SampleUserTbl.xml"
                If Not System.IO.File.Exists(Str_FileName) Then
                    ' ユーザー定義ファイルが存在しない.
                    MsgBox("ユーザー定義ファイル、フォルダを作成します。" & vbCrLf & "ファイル名：" & Str_FileName)
                    Bln_FileWrite = True
                Else
                    ' ユーザー定義ファイルを読込ます.
                    ClsPub_Server.ReadUserList(Str_FileName)
                End If

                If ClsPub_Server.GetUserCount() = 0 Then
                    ' ユーザー件数が0件の場合は、サンプルユーザーを追加します.
                    MyClass.AddSampleUser()
                End If

                If Bln_FileWrite Then
                    ClsPub_Server.StdFolder = StrCls_StdFolder
                    ' ユーザー定義ファイルに書き込みます.
                    ClsPub_Server.WriteUserList(Str_FileName)
                End If

            Catch ex As Exception

            End Try
        End Sub

        #Region "Sub AddSampleUser : ユーザーリストにサンプルユーザーを追加します."
            Private Sub AddSampleUser()
                Try
                    ' 基準フォルダの設定.
                    ClsPub_Server.StdFolder = Application.StartupPath & "\SampleDataFolder" 
                    IO.Directory.CreateDirectory(ClsPub_Server.StdFolder)
                    For Int_Loop As Integer = 0 To 49
                        Dim Cls_User As New NSDSocket.NSD_SocketUserInfo.NSDUserInfo
                        With Cls_User
                            .Name = "テストユーザー " & Format(Int_Loop, "0000")
                            .LoginName = "TEST" & Format(Int_Loop, "0000")
                            .Password = "TestPw" & Format(Int_Loop, "0000")
                            .Description = "テスト用のユーザー" & Format(Int_Loop, "0000")
                            .StdFolderName = "TEST" & Format(Int_Loop, "0000")
                            IO.Directory.CreateDirectory(StrCls_StdFolder & IO.Path.DirectorySeparatorChar & .StdFolderName)
                            .FileAuthority = NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_All
                            If (Int_Loop mod 2) Then
                                .FileAuthority = NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_Read
                            End If
                        End With

                        ClsPub_Server.AddUserList(Cls_User)
                    Next Int_Loop

                Catch ex As Exception

                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Frm_Server_FormClosed : FormClosedイベント."
        Private Sub Frm_Server_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
            Try
                If Not (ClsPub_Server Is Nothing) Then
                    ClsPub_Server.Dispose()
                    ClsPub_Server = Nothing
                End If
            Catch ex As Exception
            End Try
        End Sub
    #End Region

    #Region "Sub Button1_Click : 受信開始."
        Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
            Try
                Do
                    Select Case ClsPub_Server.ServerState
                        Case NSDSocket.NSDServerInfo.SERVER_STATE.Listening
                            ' 受信待ち状態.
                            ClsPub_Server.ListenEnd()

                            With Me.LV_Info
                                For Int_Loop As Integer = 0 To .Items.Count - 1
                                    Dim One_Receive As NSDSocket.NSDReceive = .Items(Int_Loop).Tag
                                    If Not (One_Receive Is Nothing) Then
                                        One_Receive.Dispose()
                                        One_Receive = Nothing
                                    End If
                                Next
                                .Items.Clear()
                            End With

                            ' ----------------------------------------------------
                            ' 各イベントハンドルを解除します.
                            ' ----------------------------------------------------
                                ' クライアントが接続した場合に発生します.
                                RemoveHandler ClsPub_Server.AcceptedClient, AddressOf MyClass.AcceptedClient
                                ' ログインした場合に発生します.
                                RemoveHandler ClsPub_Server.ReceivedClient_Login, AddressOf MyClass.ReceivedClient_Login
                                ' クライアントが切断した時に発生します.
                                RemoveHandler ClsPub_Server.DisconnectedClient, AddressOf MyClass.DisconnectedClient
                                ' クライアントからデータを受信した時に発生します.
                                RemoveHandler ClsPub_Server.ReceivedClientData, AddressOf MyClass.ReceiveData
                                ' クライアントから受信したアップロードデータを書き込んだ時に発生します.
                                RemoveHandler ClsPub_Server.ReceivedClientUploadData, AddressOf MyClass.ReceivedUploadData

                                ' ダウンロード用.
                                    ' クライアントへダウンロードデータを送信した後に発生します.
                                    RemoveHandler ClsPub_Server.SendClientDownloadData, AddressOf MyClass.SendDownloadData
                                    ' クライアントがダウンロード中止した時に発生します.
                                    RemoveHandler ClsPub_Server.SendClientDownloadStop, AddressOf MyClass.SendDownloadStop
                                    ' クライアントからダウンロード終了を受信した時に発生します.
                                    RemoveHandler ClsPub_Server.SendClientDownloadEnd, AddressOf MyClass.SendDownloadEnd
                            
                            Me.Button1.Text = "受信開始"
                            Me.NUD_PortNo.Enabled = True

                        Case Else
                            ' ポート番号をセット.
                            ClsPub_Server.PortNo = Me.NUD_PortNo.Value
                            Dim Bln_Err As Boolean = True
                            Try
                                ' 受信待ちを開始します.
                                ClsPub_Server.Listen()
                                Bln_Err = False
                            Catch ex As Exception
                            End Try
                            If Bln_Err Then
                                MsgBox("受信待ちが開始できません。")
                               Exit Do
                            End If

                            ' ----------------------------------------------------
                            ' 各イベントハンドルを追加します.
                            ' ----------------------------------------------------
                                ' クライアントが接続した場合に発生します.
                                AddHandler ClsPub_Server.AcceptedClient, AddressOf MyClass.AcceptedClient
                                ' ログインした場合に発生します.
                                AddHandler ClsPub_Server.ReceivedClient_Login, AddressOf MyClass.ReceivedClient_Login

                                ' クライアントが切断した時に発生します.
                                AddHandler ClsPub_Server.DisconnectedClient, AddressOf MyClass.DisconnectedClient
                                ' クライアントからデータを受信した時に発生します.
                                AddHandler ClsPub_Server.ReceivedClientData, AddressOf MyClass.ReceiveData
                                ' クライアントから受信したアップロードデータを書き込んだ時に発生します.
                                AddHandler ClsPub_Server.ReceivedClientUploadData, AddressOf MyClass.ReceivedUploadData
                                ' アップロード終了時に発生します.
                                AddHandler ClsPub_Server.ReceivedClientUploadEnd, AddressOf MyClass.ReceivedUploadEnd

                                ' ダウンロード用.
                                    ' クライアントへダウンロードデータを送信した後に発生します.
                                    AddHandler ClsPub_Server.SendClientDownloadData, AddressOf MyClass.SendDownloadData
                                    ' クライアントがダウンロード中止した時に発生します.
                                    AddHandler ClsPub_Server.SendClientDownloadStop, AddressOf MyClass.SendDownloadStop
                                    ' クライアントからダウンロード終了を受信した時に発生します.
                                    AddHandler ClsPub_Server.SendClientDownloadEnd, AddressOf MyClass.SendDownloadEnd

                            Me.Button1.Text = "受信停止"
                            With Me.NUD_PortNo
                                .Value = ClsPub_Server.PortNo
                                .Enabled = False
                            End With
                    End Select
                Loop While (False)

            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub AcceptedClient : クライアントを受け入れた時に発生します."
        Private Sub AcceptedClient(ByVal sender As Object, ByVal e As NSDSocket.NSDServerEventArgs)
            Try
            Catch ex As Exception
            End Try
        End Sub
    #End Region

    #Region "Sub ReceivedClient_Login : ログインした時に発生します."
        Private Sub ReceivedClient_Login(ByVal sender As Object, ByVal e As NSDSocket.NSDReceiveLoginEventArgs)
            Try
                Dim Str_LoginName As String = e.UserInfo.LoginName
                Dim Str_UserName As String = e.UserInfo.Name
                Dim Date_ConnectTime As DateTime = e.Receive.ReceiveInfo.dSocketConnectTime
                MyClass.Set_ListView_Info(Str_LoginName, Str_UserName, Date_ConnectTime, e.Receive)
            Catch ex As Exception
            End Try
        End Sub

        #Region "Sub Set_ListView_Info : ListViewに設定します."
            Private Sub Set_ListView_Info(ByVal StrVal_LoginName As String, ByVal StrVal_UserName As String, ByVal DateVal_ConnectTime As DateTime, ByVal ClsVal_Receive As NSDSocket.NSDReceive)
                Try
                    If Me.InvokeRequired() Then
                        Dim SLI As New Set_LV_Info_Delegate(AddressOf Set_ListView_Info)
                        Me.Invoke(SLI, New Object(){StrVal_LoginName, StrVal_UserName, DateVal_ConnectTime, ClsVal_Receive})
                    Else
                        With Me.LV_Info
                            ' ログイン名.
                            Dim LItem As ListViewItem = .Items.Add(StrVal_LoginName)
                            ' ユーザ名.
                            LItem.SubItems.Add(StrVal_UserName)
                            ' 接続時刻.
                            LItem.SubItems.Add(DateVal_ConnectTime.ToString())
                            ' アップロード情報.
                            LItem.SubItems.Add("-")
                            ' ダウンロード情報.
                            LItem.SubItems.Add("-")

                            LItem.Tag = ClsVal_Receive
                        End With
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub DisconnectedClient : クライアントが切断した時に発生します."
        Private Sub DisconnectedClient(ByVal sender As Object, ByVal e As NSDSocket.NSDServerEventArgs)
            Try
                MyClass.Delete_LV_Info(e)
            Catch ex As Exception
            End Try
        End Sub

        #Region "Sub Delete_LV_Info : 切断したクライアントの解放処理."
            Private Sub Delete_LV_Info(ByVal e As NSDSocket.NSDServerEventArgs)
                Try
                    If Me.InvokeRequired() Then
                        Dim DLID As New Delete_LV_Info_Delegate(AddressOf Delete_LV_Info)
                        Me.Invoke(DLID, New Object(){e})
                    Else
                        With Me.LV_Info
                            For Int_Loop As Integer = 0 To .Items.Count - 1
                                If Object.Equals(.Items(Int_Loop).Tag, e.Receive) Then
                                    Dim OneReceive As NSDSocket.NSDReceive = CType(.Items(Int_Loop).Tag, NSDSocket.NSDReceive)
                                    OneReceive.Dispose()
                                    .Items(Int_Loop).Tag = Nothing
                                    .Items.RemoveAt(Int_Loop)
                                    Exit For
                                End If
                            Next
                        End With
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "クライアントからデータを受信した時に発生します."
        Private Sub ReceiveData(ByVal sender As Object, ByVal e As NSDSocket.NSDReceiveDataEventArgs)

        End Sub
    #End Region

    #Region "アップロード用の表示."
        #Region "Sub ReceivedUploadData : アップロードの受信状態を表示します."
            Private Sub ReceivedUploadData(ByVal sender As Object, ByVal e As NSDSocket.NSDReceiveWriteDataEventArgs)
                Try
                    MyClass.Set_LV_UploadInfo(e)
                Catch ex As Exception
                End Try
            End Sub

            #Region "Sub Set_LV_UploadInfo : ListViewのアップロード情報を設定します."
                Private Sub Set_LV_UploadInfo(ByVal e As NSDSocket.NSDReceiveWriteDataEventArgs)
                    Try
                        If Me.InvokeRequired() Then
                            Dim SLU As New Set_LV_UploadInfo_Delegate(AddressOf Set_LV_UploadInfo)
                            Me.Invoke(SLU, e)
                        Else
                            With Me.LV_Info
                                For Int_Loop As Integer = 0 To .Items.Count - 1
                                    Dim LItem As ListViewItem = .Items(Int_Loop)
                                    Dim One_Receive As NSDSocket.NSDReceive = LItem.Tag
                                    If One_Receive.ReceiveInfo.Equals(e.ReceiveInfo) Then
                                        LItem.SubItems(3).Text = e.WriteSize.ToString() & "/" & e.TotalSize.ToString()
                                    End If
                                Next
                            End With
                        End If
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region
        #End Region

        #Region "Sub ReceivedUploadEnd : アップロードの終了を設定します."
            Private Sub ReceivedUploadEnd(ByVal sender As Object, ByVal e As NSDSocket.NSDReceiveWriteDataEventArgs)
                Try
                    MyClass.Set_LV_UploadEnd(e)
                Catch ex As Exception
                End Try
            End Sub

            #Region "Sub Set_LV_UploadEnd : ListViewのアップロード情報を設定します."
                Private Sub Set_LV_UploadEnd(ByVal e As NSDSocket.NSDReceiveWriteDataEventArgs)
                    Try
                        If Me.InvokeRequired() Then
                            Dim SLU As New Set_LV_UploadInfo_Delegate(AddressOf Set_LV_UploadEnd)
                            Me.Invoke(SLU, e)
                        Else
                            With Me.LV_Info
                                For Int_Loop As Integer = 0 To .Items.Count - 1
                                    Dim LItem As ListViewItem = .Items(Int_Loop)
                                    Dim One_Receive As NSDSocket.NSDReceive = LItem.Tag
                                    If One_Receive.ReceiveInfo.Equals(e.ReceiveInfo) Then
                                        LItem.SubItems(3).Text = "-"
                                    End If
                                Next
                            End With
                        End If
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region
        #End Region
    #End Region

    #Region "ダウンロード用の表示."
        #Region "Sub SendDownloadData : ダウンロードの送信状態を表示します."
            Private Sub SendDownloadData(ByVal sender As Object, ByVal e As NSDSocket.NSDSendDataEventArgs)
                Try
                    MyClass.Set_LV_DownloadInfo(e)
                Catch ex As Exception
                End Try
            End Sub

            #Region "Sub Set_LV_DownloadInfo : ListViewのダウンロード情報を設定します."
                Private Sub Set_LV_DownloadInfo(ByVal e As NSDSocket.NSDSendDataEventArgs)
                    Try
                        If Me.InvokeRequired() Then
                            Dim SLU As New Set_LV_DownloadInfo_Delegate(AddressOf Set_LV_DownloadInfo)
                            Me.Invoke(SLU, e)
                        Else
                            With Me.LV_Info
                                For Int_Loop As Integer = 0 To .Items.Count - 1
                                    Dim LItem As ListViewItem = .Items(Int_Loop)
                                    Dim One_Receive As NSDSocket.NSDReceive = LItem.Tag
                                    If One_Receive.ReceiveInfo.Equals(e.ReceiveInfo) Then
                                        LItem.SubItems(4).Text = e.SenderSize.ToString() & "/" & e.TotalSize.ToString()
                                    End If
                                Next
                            End With
                        End If
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region
        #End Region

        #Region "Sub SendDownloadStop : ダウンロードの中止."
            Private Sub SendDownloadStop(ByVal sender As Object, ByVal e As NSDSocket.NSDSendDataEventArgs)
                Try
                    MyClass.Set_LV_DownloadStopEnd(e)
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub SendDownloadEnd : ダウンロードの終了."
            Private Sub SendDownloadEnd(ByVal sender As Object, ByVal e As NSDSocket.NSDSendDataEventArgs)
                Try
                    MyClass.Set_LV_DownloadStopEnd(e)
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Set_LV_DownloadStopEnd : ListViewのダウンロード終了を設定します."
            Private Sub Set_LV_DownloadStopEnd(ByVal e As NSDSocket.NSDSendDataEventArgs)
                Try
                    If Me.InvokeRequired() Then
                        Dim SLU As New Set_LV_DownloadInfo_Delegate(AddressOf Set_LV_DownloadStopEnd)
                        Me.Invoke(SLU, e)
                    Else
                        With Me.LV_Info
                            For Int_Loop As Integer = 0 To .Items.Count - 1
                                Dim LItem As ListViewItem = .Items(Int_Loop)
                                Dim One_Receive As NSDSocket.NSDReceive = LItem.Tag
                                If One_Receive.ReceiveInfo.Equals(e.ReceiveInfo) Then
                                    LItem.SubItems(4).Text = "-"
                                End If
                            Next
                        End With
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "Sub Btn_User_Click : ユーザー設定."
        Private Sub Btn_User_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_User.Click
            Using frm As New Frn_UserList
                frm.ShowDialog
            End Using
        End Sub
    #End Region

End Class