﻿Public Class Frn_UserList
    #Region "Sub Frn_UserList_Load : Loadイベント."
        Private Sub Frn_UserList_Load( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles MyBase.Load
            Try
                ' ユーザーリストにユーザーを表示します.
                MyClass.SetUserList()
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub SetUserList : ユーザーリストにユーザーを表示します."
        Private Sub SetUserList()
            Try
                Me.ListView1.Items.Clear()
                Dim Cls_UserList As System.Collections.ArrayList = ClsPub_Server.GetUserList()
                If Not (Cls_UserList Is Nothing) Then
                    For Each u As NSDSocket.NSD_SocketUserInfo.NSDUserInfo In Cls_UserList
                        ' ユーザーを追加します.
                        With Me.ListView1.Items
                            Dim Li As ListViewItem = .Add(u.Name)
                            ' ログイン名.
                            Li.SubItems.Add(u.LoginName)
                            ' 説明.
                            Li.SubItems.Add(u.Description)
                            ’フォルダ名.
                            Li.SubItems.Add(u.StdFolderName)
                            ' 最大サイズ.
                            Li.SubItems.Add(u.IntFolderMaxSize)
                            ' ファイル読込.
                            Li.SubItems.Add(IIf(u.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_Read, "○", "Ｘ"))
                            ' ファイル作成.
                            Li.SubItems.Add(IIf(u.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileCreate, "○", "Ｘ"))
                            ' ファイル上書.
                            Li.SubItems.Add(IIf(u.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileOverWrite, "○", "Ｘ"))
                            ' ファイル削除.
                            Li.SubItems.Add(IIf(u.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileDelete, "○", "Ｘ"))

                            ' クラスを設定.
                            Li.Tag = u
                        End With
                    Next
                End If
                ' ユーザー定義ファイルをセットします.
                Me.Txt_File.Text = ClsPub_Server.UserFileName

            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Read_Click : 読込."
        Private Sub Btn_Read_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Read.Click
            Try
                Using fd As New OpenFileDialog
                    fd.FileName = Me.Txt_File.Text
                    fd.Filter = "xmlファイル (*.xml)|*.xml|全ファイル (*.*)|*.*"
                    If fd.ShowDialog() = Windows.Forms.DialogResult.OK Then
                        If MsgBox("ユーザー定義ファイルを読込ます。" & vbCrLf & "よろしいですか？", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                            Me.Txt_File.Text = fd.FileName

                            ' ユーザー定義ファイルを読み込みます.
                            If Not ClsPub_Server.ReadUserList(fd.FileName) Then
                                MsgBox("ユーザー定義ファイルの読込に失敗しました。")
                            End If
                        End If
                    End If
                End Using
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Write_Click : 保存."
        Private Sub Btn_Write_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Write.Click
            Try
                Using fd As New SaveFileDialog
                    fd.FileName = Me.Txt_File.Text
                    fd.Filter = "xmlファイル (*.xml)|*.xml|全ファイル (*.*)|*.*"
                    If fd.ShowDialog() = Windows.Forms.DialogResult.OK Then
                        If MsgBox("ユーザー定義ファイルを保存します。" & vbCrLf & "よろしいですか？", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                            Me.Txt_File.Text = fd.FileName

                            ' ユーザー定義ファイルを書き込みます.
                            If Not ClsPub_Server.WriteUserList(fd.FileName) Then
                                MsgBox("ユーザー定義ファイルの書き込みに失敗しました。")
                            End If
                        End If
                    End If
                End Using
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Add_Click : 追加."
        Private Sub Btn_Add_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Add.Click
            Try
                IntPub_UserInfoStyle = 0    ' 追加.
                Using frm As New Frm_User
                    If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
                        ' ユーザーを追加します.
                        With Me.ListView1.Items
                            Dim Li As ListViewItem = .Add(ClsPub_UserInfo.Name)
                            ' ログイン名.
                            Li.SubItems.Add(ClsPub_UserInfo.LoginName)
                            ' 説明.
                            Li.SubItems.Add(ClsPub_UserInfo.Description)
                            ’フォルダ名.
                            Li.SubItems.Add(ClsPub_UserInfo.StdFolderName)
                            ' 最大容量.
                            Li.SubItems.Add(ClsPub_UserInfo.IntFolderMaxSize)
                            ' ファイル権限.
                                ' ファイル読込.
                                Li.SubItems.Add(IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_Read, "○", "Ｘ"))
                                ' ファイル作成.
                                Li.SubItems.Add(IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileCreate, "○", "Ｘ"))
                                ' ファイル上書.
                                Li.SubItems.Add(IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileOverWrite, "○", "Ｘ"))
                                ' ファイル削除.
                                Li.SubItems.Add(IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileDelete, "○", "Ｘ"))

                            ' ユーザーを追加します.
                            If ClsPub_Server.AddUserList(ClsPub_UserInfo) = NSDSocket.NSD_SocketUserInfo.ERR_KIND.OK Then
                                ' クラスを設定.
                                Li.Tag = ClsPub_UserInfo
                            Else
                                MsgBox("追加に失敗しました。")
                            End If
                        End With
                    End If
                End Using

            Catch ex As Exception
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Edit_Click : 編集."
        Private Sub Btn_Edit_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Edit.Click
            Try
                IntPub_UserInfoStyle = 1    ' 編集.
                If Not (Me.ListView1.SelectedItems Is Nothing) Then
                    ClsPub_UserInfo = Me.ListView1.SelectedItems(0).Tag
                    Using frm As New Frm_User
                        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
                            ' ユーザーを変更します.
                            With Me.ListView1
                                Dim Li As ListViewItem = .SelectedItems(0)
                                ' ユーザー名.
                                Li.Text = ClsPub_UserInfo.Name
                                ' ログイン名.
                                Li.SubItems(1).Text = ClsPub_UserInfo.LoginName
                                ' 説明.
                                Li.SubItems(2).Text = ClsPub_UserInfo.Description
                                ’フォルダ名.
                                Li.SubItems(3).Text = ClsPub_UserInfo.StdFolderName
                                ' 最大容量.
                                Li.SubItems(4).Text = ClsPub_UserInfo.IntFolderMaxSize

                                ' ファイル権限.
                                    ' ファイル読込.
                                    Li.SubItems(5).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_Read, "○", "Ｘ")
                                    ' ファイル作成.
                                    Li.SubItems(6).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileCreate, "○", "Ｘ")
                                    ' ファイル上書.
                                    Li.SubItems(7).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileOverWrite, "○", "Ｘ")
                                    ' ファイル削除.
                                    Li.SubItems(8).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileDelete, "○", "Ｘ")

                                ' クラスを設定.
                                Li.Tag = ClsPub_UserInfo
                            End With
                            ' ユーザーを変更します.
                            If ClsPub_Server.ChangeUserList(ClsPub_UserInfo) <> NSDSocket.NSD_SocketUserInfo.ERR_KIND.OK Then
                                MsgBox("変更に失敗しました。")

                                If ClsPub_Server.GetUserToUserList(ClsPub_UserInfo.ID, ClsPub_UserInfo) = NSDSocket.NSD_SocketUserInfo.ERR_KIND.OK Then
                                    ' ユーザーを再設定します.
                                    With Me.ListView1
                                        Dim Li As ListViewItem = .SelectedItems(0)
                                        ' ユーザー名.
                                        Li.Text = ClsPub_UserInfo.Name
                                        ' ログイン名.
                                        Li.SubItems(1).Text = ClsPub_UserInfo.LoginName
                                        ' 説明.
                                        Li.SubItems(2).Text = ClsPub_UserInfo.Description
                                        ’フォルダ名.
                                        Li.SubItems(3).Text = ClsPub_UserInfo.StdFolderName
                                        ' 最大容量.
                                        Li.SubItems(4).Text = ClsPub_UserInfo.IntFolderMaxSize

                                        ' ファイル権限.
                                            ' ファイル読込.
                                            Li.SubItems(5).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_Read, "○", "Ｘ")
                                            ' ファイル作成.
                                            Li.SubItems(6).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileCreate, "○", "Ｘ")
                                            ' ファイル上書.
                                            Li.SubItems(7).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileOverWrite, "○", "Ｘ")
                                            ' ファイル削除.
                                            Li.SubItems(8).Text = IIf(ClsPub_UserInfo.FileAuthority And NSDSocket.NSD_SocketUserInfo.NSDUserInfo.ReadWrite_Authority.Authority_FileDelete, "○", "Ｘ")

                                        ' クラスを設定.
                                        Li.Tag = ClsPub_UserInfo
                                    End With
                                End If
                            End If
                        End If
                    End Using
                End If
            Catch ex As Exception
            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Delete_Click : 削除."
        Private Sub Btn_Delete_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Delete.Click
            Try
                If Not (Me.ListView1.SelectedItems Is Nothing) Then
                    ClsPub_UserInfo = Me.ListView1.SelectedItems(0).Tag
                    If MsgBox("ユーザー名：" & ClsPub_UserInfo.Name & vbCrLf & "を削除します。" & vbCrLf & "よろしいですか?", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                        If ClsPub_Server.DeleteUserList(ClsPub_UserInfo) = NSDSocket.NSD_SocketUserInfo.ERR_KIND.OK Then
                            If Not String.IsNullOrEmpty(ClsPub_Server.UserFileName) Then
                                ' ユーザーリストを保存します.
                                ClsPub_Server.WriteUserList(ClsPub_Server.UserFileName)
                            End If
                            ' ユーザーリストにユーザーを表示します.
                            SetUserList()
                        End If
                    End If
                End If
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub ListView1_MouseDoubleClick : 編集"
        Private Sub ListView1_MouseDoubleClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles ListView1.MouseDoubleClick
            Try
                Me.Btn_Edit.PerformClick()
            Catch ex As Exception
            End Try
        End Sub
    #End Region
End Class